*                                       
*                           Circle Development Systems
*                             2639 Central Ave. #X-2
*                              Memphis, Tn.  38104
*                              Phone: 901-327-2237
*                                       
*                                       
*   PROGRAM/VER.   : CALCULTR.PRG   Version 1.00
*   MAIN PROCEDURE : CALC
*   AUTHOR         : RODGERS MOORE Jr.
*   COMPILER/VER.  : CLIPPER SUMMER 87
*   DATE COMPLETED : 07/11/88
*
*******************************************************************************
*
*   PURPOSE   :  This program was written for the purpose of giving end-users
*                access to an adding machine, if they do not have one; or if
*                they do, to reduce desk clutter.
*
*   DISCLAIMER:  This program is to be added INTO an existing system.
*                This program emulates an adding machine as close as possible,
*                and may take a little getting used to, because not all
*                functions are implemented.  Circle Development Systems and
*                Rodgers Moore Jr. cannot and will not be held liable for
*                any occurrence deriving from the use of this software
*                program.  The user, by possessing this software program, by
*                default agrees to be responsible for its use.
*
*   PLEA      :  I (Rodgers Moore) spent a few days perfecting this program.
*                If you like what I have done and you intend to use it, all I
*                ask for is a donation in the amount of whatever you think it
*                is worth to you.  If you like it and don't send a donation
*                may ants infest your hard disk!  So remember, it is more
*                likely that I will put more nifty programs in public domain,
*                if you are honest.  Also remember, I put no restrictions on
*                its use.  You may include it in programs you sell.
*                PLEASE, write and tell me what you think.
*
*
*   NOTES     :  To include this program into software you already have, just
*                follow the simple steps below:
*
*                   1.)  At or near the beginning of your main program file,
*                        insert the following commands:
*                          SET KEY n TO CALC  where "n" is the scan code 
*                                             returned by INKEY() for the key
*                                             you want to activate the 
*                                             calculator.
*                                             (I use "-8" for function key F9)
*
*                          PUBLIC CHAR        This is required for the program
*                                             to function.
*
*                   2.)  Insert or append this file to any .PRG file that is
*                        not included in an overlay.  This file may be included
*                        in an overlay, if you know what you're doing.
*
*                   3.)  ** OPTIONAL **  Delete this header of comments.
*
*                   4.)  Recompile your software and you're finished!
*
*   ***
*   IMPORTANT->  The [ESC] key exits the calculator.
*   ***          The [ENTER] key is the Total key.
*                The [DELETE] key deletes numeric key presses in LIFO order.
*                This program emulates an adding machine NOT a calculator.
*                  They don't work the same way.
*                You must always press the decimal key to set its position,
*                  if you don't want the number you entered divided by 100.
*                The "SET KEY n TO proc" command only works during wait states,
*                  so you'll have to add some code to your programs, if you 
*                  use INKEY().
*
*
*        THIS PROGRAM IS NOT COMMENTED.
*
*        Programs should not be commented.
*        Programs should be as hard to understand as they are to write.
*        (Guru Programming Proverb #1)
*
*        Programs should be commented after they are finished.
*        No program is ever finished.
*        (Guru Programming Proverb #2)
*
*******************************************************************************



********************** ADDING MACHINE EMULATOR ********************************
PROC CALC
PRIV TEMP,NUM,FINI,VALID,ACCUM

     SAVE SCREEN TO TEMP
     SET COLOR TO +W
     @  5,27 CLEAR TO 24,79
     @  5,27 TO 24,79
     @  6,51 TO 23,51
     @  5,51 SAY ''
     @ 24,51 SAY ''
     @  6,28 TO  8,50
     @  9,34 TO 11,38
     @  9,40 TO 11,44
     @  9,46 TO 11,50
     @ 12,28 TO 14,32
     @ 12,34 TO 14,38
     @ 12,40 TO 14,44
     @ 12,46 TO 17,50
     @ 15,28 TO 17,32
     @ 15,34 TO 17,38
     @ 15,40 TO 17,44
     @ 18,28 TO 20,32
     @ 18,34 TO 20,38
     @ 18,40 TO 20,44
     @ 18,46 TO 23,50
     @ 21,28 TO 23,38
     @ 21,40 TO 23,44
     SET COLOR TO +W
     @ 10,36 SAY ''
     @ 10,42 SAY '*'
     @ 10,48 SAY '-'
     @ 13,30 SAY '7'
     @ 13,36 SAY '8'
     @ 13,42 SAY '9'
     @ 14,48 SAY '+'
     @ 16,30 SAY '4'
     @ 16,36 SAY '5'
     @ 16,42 SAY '6'
     @ 19,30 SAY '1'
     @ 19,36 SAY '2'
     @ 19,42 SAY '3'
     @ 20,48 SAY 'T'
     @ 22,33 SAY '0'
     @ 22,42 SAY ''
     SET COLOR TO W
     FINI = .F.
     ACCUM = 0.0
     CHAR = ' '
     NUM = 0
     DO WHILE !FINI
       SET COLOR TO /W
       @ 7,29 SAY ACCUM PICT '99,999,999,999,999.99'
       NUM = NUMINPUT(NUM)
       SET COLOR TO W
       DO CASE
          CASE CHAR = '+'
            SET COLOR TO /W
            @ 14,48 SAY '+'
            ACCUM = ACCUM + NUM
            SCROLL(6,57,23,78,1)
            SET COLOR TO +W
            @ 23,57 SAY NUM PICT '99,999,999,999,999.99'
            @ 23,78 SAY '+'
            @ 14,48 SAY '+'
          CASE CHAR = '-'
            SET COLOR TO /W
            @ 10,48 SAY '-'
            ACCUM = ACCUM - NUM
            SCROLL(6,57,23,78,1)
            SET COLOR TO +W
            @ 23,57 SAY NUM PICT '99,999,999,999,999.99'
            @ 23,78 SAY '-'
            @ 10,48 SAY '-'
          CASE CHAR = '*'
            SET COLOR TO /W
            @ 10,42 SAY '*'
            SCROLL(6,57,23,78,1)
            SET COLOR TO +W
            @ 23,57 SAY NUM PICT '99,999,999,999,999.99'
            @ 23,78 SAY '*'
            ACCUM = ACCUM * NUM
            @ 10,42 SAY '*'
          CASE CHAR = '/' .AND. ACCUM <> 0
            SET COLOR TO /W
            @ 10,36 SAY ''
            SCROLL(6,57,23,78,1)
            SET COLOR TO +W
            @ 23,57 SAY NUM PICT '99,999,999,999,999.99'
            @ 23,78 SAY ''
            ACCUM = ACCUM / NUM
            ACCUM = INT((ACCUM + 0.005)*100)/100
            @ 10,36 SAY ''
          CASE CHAR = CHR(13)
            SCROLL(6,57,23,78,1)
            @ 23,57 SAY ACCUM PICT '99,999,999,999,999.99'
            @ 23,78 SAY 'T'
            ACCUM = 0.0
            NUM = 0
          CASE CHAR = CHR(27)
            FINI = .T.
       ENDCASE
     ENDDO
     CHAR = ' '
     RESTORE SCREEN FROM TEMP
     RETURN


******************** NUMBER INPUT FUNCTION FOR ADDING MACHINE *****************
FUNC NUMINPUT
PARA VALUE
PRIV THRU,T_NUM,PLACE,NEW

     SET COLOR TO /W
     PLACE = 1
     NEW = .T.
     DECIMAL = .F.
     THRU = .F.
     DO WHILE !THRU
       @ 7,47 SAY ''
       T_NUM = INKEY()
       IF T_NUM > 0
         CHAR = CHR(T_NUM)
         IF CHAR $ '0123456789'
           SET COLOR TO /W
           IF CHAR = '0'
             @ 22,33 SAY '0'
           ELSE
             @ 19-(INT((VAL(CHAR)-1)/3)*3),30+(((VAL(CHAR)-1)%3)*6) SAY CHAR
           ENDIF
           IF NEW
             VALUE = VAL(CHAR)
             NEW = .F.
           ELSE
             IF !DECIMAL
               VALUE = (VALUE * 10) + VAL(CHAR)
             ELSE
               IF PLACE = 1
                 PLACE = 2
                 VALUE = INT(VALUE) + (VAL(CHAR)/10)
               ELSE
                 VALUE = (INT(VALUE*10)/10) + (VAL(CHAR)/100)
               ENDIF
             ENDIF
           ENDIF
           @ 7,29 SAY VALUE PICT '99,999,999,999,999.99'
           SET COLOR TO +W
           IF CHAR = '0'
             @ 22,33 SAY '0'
           ELSE
             @ 19-(INT((VAL(CHAR)-1)/3)*3),30+(((VAL(CHAR)-1)%3)*6) SAY CHAR
           ENDIF
           SET COLOR TO /W
         ELSE
           DO CASE
              CASE CHAR $ '+-*/'+CHR(13)
                IF !NEW .AND. !DECIMAL
                  VALUE = VALUE / 100
                ENDIF
                THRU = .T.
              CASE CHAR = '.'
                DECIMAL = .T.
                IF NEW
                  VALUE = 0
                  NEW = .F.
                ENDIF
                @ 7,29 SAY VALUE PICT '99,999,999,999,999.99'
              CASE CHAR $ CHR(127)+CHR(7)
                IF !DECIMAL
                  VALUE = INT(VALUE/10)
                ELSE
                  IF PLACE = 1
                    DECIMAL = .F.
                    VALUE = INT(VALUE)
                  ELSE
                    PLACE = 1
                    VALUE = INT(VALUE*10)/10
                  ENDIF
                ENDIF
                @ 7,29 SAY VALUE PICT '99,999,999,999,999.99'
              CASE CHAR = CHR(6)
                PLACE = 1
                NEW = .F.
                DECIMAL = .F.
                VALUE = 0
                @ 7,29 SAY VALUE PICT '99,999,999,999,999.99'
              CASE CHAR = CHR(27)
                @ 7,29 SAY VALUE PICT '99,999,999,999,999.99'
                THRU = .T.
           ENDCASE
         ENDIF
       ENDIF
     ENDDO
     SET COLOR TO +W
     RETURN(VALUE)


*******************************************************************************
*  EOF: CALCULTR.PRG
*******************************************************************************
