* Help support the Clipper Developement Community by letting your customers
* know what their applications were developed with.  Include the following
* Nantucket(tm) Logo on the closing screen of your applications.  This will
* benefit all Clipper developers by increasing end-user awareness, and will
* distancr our products from "dBASE" by establishing Clipper as a solid,
* independant developement environment.

* Sample code to demonstrate the Logo's... 
@ 0, 0 clear
NanLogo( 2, 0 )              && Full-Size Nantucket Logo
SNanLogo( 2, 45 )            && "Small" Nantucket Logo
@ 20, 0 say "Press any key..."
inkey( 0 )
@ 20, 0
return


* NanLogo(): Displays a Nantucket Logo on the screen along with
*            a short message promoting Clipper applications.
*      Size: The displayed Logo is 17 rows long and 40 columns wide.
*     Usage: NanLogo( row, col ) where row and col are the upper
*            left coordinates for the Logo.  If omited they 
*            defalut to the current screen position.
*    Author: Written by Steve Klingler of Programming Solutions, Inc.
*            SLC, UT.  CIS ID: 73320,3117
*      Note: Nantucket, Clipper, and the Nantucket Logo are 
*            trademarks of Nantucket Copr.
function NanLogo
    parameters top, left        && Logo Top and Left coordinates
    private prevColor, logoColor, textColor, regColor
    prevColor= setcolor()
    logoColor= iif( iscolor(), "B/G", "W/N" )
    textColor= iif( iscolor(), "W+/G", "W+/N" )
    regColor=  iif( iscolor(), "N/B", "N/W" )
    if ( type( "top" ) # 'N' )&& Verify that the values were passed
        top= row()
    endif
    if ( type( "left" ) # 'N' )
        left= col()
    endif
    setcolor( textColor )   
    @ top +  0, left say "Nantucket                        Clipper"
    setcolor( logoColor )   
    @ top +  1, left say ""
    @ top +  2, left say "         Professional Software"
    @ top +  3, left say ""
    @ top +  4, left say "        Utilizing Clipper"
    @ top +  5, left say ""
    @ top +  6, left say "          Technology"
    @ top +  7, left say ""
    @ top +  8, left say "               "
    @ top +  9, left say ""
    @ top + 10, left say "          "
    @ top + 11, left say ""
    @ top + 12, left say "     "
    @ top + 13, left say ""
    @ top + 14, left say ""
    @ top + 15, left say ""
    @ top + 16, left say ""
    setcolor( regColor )
    @ top + 16, left + 10 say "(R) Nantucket Corp"
    setcolor( prevColor )
return (.T.)


* SNanLogo(): Displays a smalefter "abbreviated" Nantucket Logo on the screen  
*             along with a short message promoting Clipper applications.
*       Size: The displayed Logo is 15 rows long and 34 columns wide.
*      Usage: SNanLogo( row, col ) where row and col are the upper
*             left coordinates for the Logo.  If omited they 
*             defalut to the current screen position.
*     Author: Written by Steve Klingler of Programming Solutions, Inc.
*             SLC, UT.  CIS ID: 73320,3117
*       Note: Nantucket, Clipper, and the Nantucket Logo are 
*             trademarks of Nantucket Copr.
function SNanLogo
    parameters top, left        && Logo Top and Left coordinates
    private prevColor, logoColor, textColor, regColor
    prevColor= setcolor()
    logoColor= iif( iscolor(), "B/G", "W/N" )
    textColor= iif( iscolor(), "W+/G", "W+/N" )
    regColor=  iif( iscolor(), "N/B", "N/W" )
    if ( type( "top" ) # 'N' )&& Verify that the values were passed
        top= row()
    endif
    if ( type( "left" ) # 'N' )
        left= col()
    endif
    setcolor( textColor )   
    @ top +  0, left say "Nantucket                  Clipper"
    setcolor( logoColor )
    @ top +  1, left say ""
    @ top +  2, left say "    Professional Software"
    @ top +  3, left say ""
    @ top +  4, left say "   Utilizing Clipper"
    @ top +  5, left say ""
    @ top +  6, left say "     Technology"
    @ top +  7, left say ""
    @ top +  8, left say "          "
    @ top +  9, left say ""
    @ top + 10, left say "     "
    @ top + 11, left say ""
    @ top + 12, left say ""
    @ top + 13, left say ""
    @ top + 14, left say ""
    setcolor( regColor )
    @ top + 14, left + 7 say "(R) Nantucket Corp"
    setcolor( prevColor )
return (.T.)

