/* --------------------------------------------------------------
   Demo program for the JG_SHADOW() and JG_COLOR() functions.
   See the accompanying READ.ME for more details.

   Compile:
      CLIPPER DEMO /A /M /N /B /W
   Link:
      BLINKER FILE DEMO,JG_SHADO

   Enjoy,
   Jim Green
   -------------------------------------------------------------- */

#include "SETCURS.CH"

PROC MAIN
LOCAL nCNT, cSCR, nKEY, nDEPTH := 0, nCOLOR := 1
LOCAL aCOLOR := {"W","W+","R","R+","BG","BG+","B+*","G","G+","GR","GR+",;
                 "RB","RB+","N", "N+" }

SETCOLOR( "W/B" )
SETCURSOR( SC_NONE )
CLS
DEVPOS(  5, 0 )
TEXT
      JG_COLOR() directly changes the color attributes of each character
      within the specified coordinates.  It can be used to hilite areas of
      the screen without disturbing the underlying text or can be used as a
      shadow function where a particular shadow color is desired.

      JG_SHADOW() is probably the ULTIMATE shadowing function!  (Pretty
      immodest, huh?)  It supports 4 shadow "depths" and is written in fast
      assembly.  The key feature of JG_SHADOW() is obviously depth option
      number 1.  Depth 1 causes JG_SHADOW() to actually analyze the color
      attribute of each character within the specified coordinates.  Based
      on what it finds, it directly changes the attribute in video memory.
      The result is a more realistic shadow effect!
ENDTEXT  // Sure TEXT/ENDTEXT is obsolete, but this is just a demo.

@ 22, 0 SAY PADC("Press any key to demonstrate JG_COLOR()",80);
    COLOR "R*+/B"
INKEY(0)
@ 22,0
@ 22,0 SAY PADC("Press any key to quit", 80 ) COLOR "R+/B"

FOR nCNT=1 TO 12
   JG_COLOR(nCNT+5, 0,nCNT+5, 79, aCOLOR[ nCNT ]+"/B" )
NEXT

FOR nCNT=5 TO 54 STEP 2
   cSCR = SAVESCREEN(5,0,20,79)
   JG_COLOR( 5, nCNT, 20, nCNT+20, "W/"+aCOLOR[ nCOLOR++ ] )
   nCOLOR = IF( nCOLOR>LEN(aCOLOR), 1, nCOLOR )
   nKEY = INKEY(.2)
   RESTSCREEN(5,0,20,79,cSCR)
   IF nKEY > 0
      EXIT
   ENDIF
NEXT

@ 22, 0 SAY PADC("Press any key to demonstrate JG_SHADOW()",80);
   COLOR "R+*/B"
INKEY(0)
@ 22,0
@ 22,0 SAY PADC("Press any key to quit", 80 ) COLOR "R+/B"

SETCOLOR("BG+/BG")

DO WHILE .T.
   cSCR = SAVESCREEN(5,20,25,60)
   JG_SHADOW( 6, 20, 17, 56, nDEPTH )
   @  5, 22, 16, 58 BOX "͸Գ "
   @  8, 25 SAY "JG_SHADOW( 6, 20, 17, 56, " + STR( nDEPTH, 1 ) + " )";
      COLOR "W+/BG"
   @  9, 25 SAY '@ 5, 22, 16, 58 BOX "͸Գ "' COLOR "W+/BG"
   nDEPTH = IF( nDEPTH=3, 0, nDEPTH+1 )
   nKEY = INKEY(3)
   RESTSCREEN(5,20,25,60,cSCR)
   IF nKEY > 0
      EXIT
   ENDIF
ENDDO

SETCURSOR( SC_NORMAL )
SETCOLOR( "W/N" )
CLS
