/***
*	extend.h
*
*	DEFINEs and EXTERNs for interfacing with Clipper from C.
*
*	Large model C only (double word pointers to code and data)
*
*	Copyright (c) Nantucket Inc. 1985
*/


/* _PARINFO types */
#define UNDEF		0
#define CHARACTER	1
#define NUMERIC		2
#define LOGICAL		4
#define DATE		8
#define ALIAS		16
#define MPTR		32		/* bitwise or'ed with type for pass by reference */
#define MEMO		65
#define WORD		128
#define ARRAY		512


/* parameter count/type */
extern int _PARINFO();
extern int _PARINFA();


/* parameter values */
extern char *_PARC();
extern int _PARNI();
extern long _PARNL();
extern double _PARND();
extern int _PARL();
extern char *_PARDS();


/* one and only one of the _ret?? functions must used */

/* Clipper-function return values */
extern _RETC();
extern _RETNI();
extern _RETNL();
extern _RETND();
extern _RETL();
extern _RETDS();

/* procedure (DO) return */
extern _RET();


/* parameter check macros */
#define PCOUNT		(_PARINFO(0))
#define ISCHAR(n)	(_PARINFO(n) & CHARACTER)
#define ISNUM(n)	(_PARINFO(n) & NUMERIC)
#define ISLOG(n)	(_PARINFO(n) & LOGICAL)
#define ISDATE(n)	(_PARINFO(n) & DATE)
#define ISMEMO(n)	(_PARINFO(n) & MEMO)
#define ISBYREF(n)	(_PARINFO(n) & MPTR)
#define ISARRAY(n)	(_PARINFO(n) & ARRAY)
#define ALENGTH(n)	(_PARINFA(n, 0))


/* DBF */
extern struct
{
   char data1[32];
   long data2[2];
} *_DBF[];

#define DBF_DATE	(_DBF[0]->data1)		/* char pointer to header */
#define REC_SIZE	(_DBF[0]->data2[0])		/* long record size */
#define DATA_OFF	(_DBF[0]->data2[1])		/* long header size */
#define DBF_OPEN	(*_DBF)

