/* EZhelp.h
**
** help system definitions
** (C) Copyright 1990, Brain Child Systems.
** All rights reserved.
*/

typedef unsigned char pairtype[2];
typedef pairtype linetype[80];
typedef linetype scrntype[25];

/*=====================================================================*/
typedef struct {

           char  tx_mnunum;         /* menu number (level) */
           char  tx_mnuord;         /* menu topic sequence number */
           char  tx_lbl[15];        /* topic choice */
           char  tx_mnulnk;         /* subsequent menu (if any) */
  unsigned int   tx_lbloff;         /* offset of topic in help text */
           int   tx_lbllen;         /* length of topic in help text */
           int   tx_lineno;         /* line number beginning topic */
           int   tx_linect;         /* number of lines of text */
  unsigned int   tx_txtlen;         /* size of help text in bytes */

} indextype;               /* 28 bytes */


/*=====================================================================*/
typedef struct {

           char menulink[3];        /* menu, order, next */
           char menunext[3];        /* next, (obtained from menulink) */
           char topic[15];          /* string of chosen topic */

           int  xcnt;               /* menu number of columns */
           int  ycnt;               /* menu number of rows */
           int  framex;             /* x coordinate of window frame */
           int  framey;             /* y coordinate of window frame */

           int  defapos;            /* what position to return to */
           int  lblset;             /* how many topics in menu set */
           int  frst_lbl;           /* first topic of menu set */
           char *scrn_buf;          /* pointer to screen text under menu */

} menu_env;        /* 36 bytes */


/*=====================================================================*/
typedef struct {

           char ref_file[41];       /* path and name of reference file */
           char bar_colo;           /* color of menu highlight bar */
           char win_colo;           /* color of help text */
           char start_menu;         /* startup menu number */
           char jump_to;            /* jump directly to a topic in a
                                       menu? 0 or the topic number of
                                       the startup menu to jump to */
           char show_errors;        /* 1 = display errors */
           int  window_size;        /* size of window 5 - 23 */
           int  window_style;       /* style of window character 0 - 8 */
           int  topic_cnt;          /* number of topics in index */

           int  anchor_flag;        /* anchor on which quadrant of screen */
                                    /* 1 - 4 clockwise, 5 = center */
} ezhelp_env;

