**********************************
FUNCTION USR_ACHO                 &&  USER FUNCTION FOR ACHOICE()
**********************************
* Written: 03/02/89   Author: Tony Castaneda   Purpose:
* User function for Clipper ACHOICE() function.  Called on every keystroke.
* Properly administers ACHOICE status, array-ptr and window-ptr params.
* In ACHOICE() call, this function name must be in quotes, "usr_acho"
* Return values: 0=abort, 1=end/return index, 2=ignore, 3=quick find letter
*
parameters status, ptr_arry, ptr_wind
private key, ckey, temp

  key = lastkey()                 &&  Get the active keystroke
  if status < 3                   &&  IF achoice status is < 3, key was UP at
     return 2                     &&  top, Down at bot, or already processed
  endif                           &&  So... Ignore and continue Achoice

  if status=4                     &&  IF achoice status=4, No Item Selectable

     temp = savescreen( 23,00,24,79 )
     @ 23,00 clear                &&  So, notify user, abort achoice
     @ 23,00 say 'NO ITEM CHOICE is selectable!'
     wait to key                  &&  In case key is needed, use lastkey()
     restscreen( 23,00,24,79, temp )

     keyboard chr(27)             &&  Optional keyboard of Esc key
     return 0                     &&  IF you have coded an escape option
  endif

*** Handle keystroke exceptions here.  Examples, Enter and Esc.
*** (Achoice normally does these actions if no user function is specified)

  do case                         &&  Based on keystroke lastkey() value

     case key=13                  &&  Enter key, exit achoice, return index
          return 1

     case key=27                  &&  Esc key, abort achoice, return 0
          keyboard chr(27)
          return 0

  otherwise
          return 2                &&  Other keys, ignore and continue achoice

  endcase
return 2

**********************************
FUNCTION USR_DBED                 &&  USER FUNCTION FOR DBEDIT()
**********************************
* Written: 03/02/89   Author: Tony Castaneda   Purpose:
* User function for Clipper DBEDIT() function.  Called on every keystroke.
* Properly administers DBEDIT status and fld-pointer params.
* In DBEDIT() call, this function name must be in quotes, "usr_dbed"
* Return values: 0=abort, 1=ignore, 2=FORCE repaint, 3=Append mode(no good)
*
parameters status, fld_ptr
private key, ckey, temp

  key = lastkey()                 &&  Get the active keystroke
  if status < 3                   &&  IF achoice status is < 3, key was UP at
     return 1                     &&  top, Down at bot, or already processed
  endif                           &&  So... Ignore and continue Dbedit

  if status=3                     &&  Empty DBEDIT Database.  Notify user!

     temp = savescreen( 23,00,24,79 )
     @ 23,00 clear
     @ 23,00 say 'THIS DATABASE IS EMPTY!'
     wait to key                  &&  In case key is needed, use lastkey()
     restscreen( 23,00,24,79, temp )

     keyboard chr(27)             &&  Optional keyboard of Esc key,
     return 0                     &&  IF you have coded an escape option
  endif

  do case                         &&  Handle valid key exceptions for dbedit

     case key=13                  &&  Enter key, mark record, exit dbedit
          record_no = recno()
          return 0

     case key=27                  &&  Esc key, abort dbedit
          return 0

     case key=28                  &&  F1 key, do Quick Find of one char
          go top
          ckey=' '

          temp = savescreen( 23,00,24,79 )
          @ 23, 00 clear          &&  ASK USER for single letter key
          wait ' Search For? ' to ckey      &&  ACCEPT command is also ok
          restscreen( 23,00,24,79, temp )

          ckey = upper(ckey)      &&  IF key field is forced to upper case

          find ( ckey )           &&  FIND first rec with this letter in key
          if .not. found()        &&  IF NONE, go top
             go top
          endif
          return 1
  otherwise
          return 1
  endcase
return 1

