@echo off
echo Ŀ
echo  File:    MAKEDEMO.BAT                                                  
echo                                                                         
echo  Purpose: Batch file to compile and link the RLIB demo program DEMO.PRG 
echo                                                                         
echo  Syntax:  makedemo                                                      
echo                                                                         
echo  Notes:   This is a batch file to make the RLIB demonstration program   
echo           DEMO.EXE from the source file DEMO.PRG supplied with the      
echo           RLIB 3.0 shareware package.                                   
echo                                                                         
echo           This batch file assumes that the Clipper 5.01 executable      
echo           files reside in the C:\CLIPPER5\BIN directory.  It also       
echo           assumes that the Clipper supplied libraries reside in         
echo           C:\CLIPPER5\LIB.  Change the directory references and         
echo           environment variable settings if your directory structure     
echo           differs from the default Clipper installation.                
echo 

:COMPILE
REM --------------------------------------------------------------------------
REM  Now compile and link.  Change the directories to point to the location
REM  where your Clipper executables and libraries (including RLIB) reside.
REM  I have left the RLIB reference to the current directory and assume the
REM  Clipper 5.01 files are in C:\CLIPPER5\BIN and the Clipper supplied
REM  library files are in C:\CLIPPER5\LIB.  If you installed Clipper 5.01
REM  into a directory other than C:\CLIPPER5 then you will need to change
REM  the paths listed below.
REM --------------------------------------------------------------------------
set CLIPPERCMD=
set LIB=C:\CLIPPER5\LIB
set INCLUDE=C:\CLIPPER5\INCLUDE
c:\clipper5\bin\clipper demo /N /W

:LINK
REM --------------------------------------------------------------------------
REM  Use the linker of your choice here.  I use BLINKER 1.5 a lot, but
REM  everyone has RTLINK because it comes with Clipper 5.01.
REM
REM  If you did not place RLIB.LIB in the current directory, add the directory
REM  where it is located to the link command.  For instance, if you placed
REM  RLIB.LIB in a directory other than the C:\CLIPPER\LIB directory that was
REM  specified in the LIB environment variable, add the directory to the RLIB
REM  reference in the link command below.
REM --------------------------------------------------------------------------
c:\clipper5\bin\rtlink FILE demo LIB clipper,rlib,extend VERBOSE

:END
