/* =========================================================================

   MouseLib.h

   Written by Steve Forbes  Clipper User Group Melbourne

   ========================================================================= */

#ifndef MOUSELIB_DEFINED

#define LBUTTON         0
#define RBUTTON         1
#define MBUTTON         2
#define ALLBUTTON       3

#define LEFT            1
#define RIGHT           2
#define MIDDLE          4
#define ALL             LEFT + RIGHT + MIDDLE

#define SOFT_TEXT_CURSOR    0
#define HARD_TEXT_CURSOR    1

void mouse_reset( int *, int * );                           /* Function  0 */
void mouse_show( void );                                    /* Function  1 */
void mouse_hide( void );                                    /* Function  2 */
void mouse_status( int *, int *, int *, int *, int * );     /* Function  3 */
void mouse_setpos( int, int );                              /* Function  4 */
void mouse_press( int, int *, int *, int *, int * );        /* Function  5 */
void mouse_release( int, int *, int *, int *, int * );      /* Function  6 */
void mouse_sethorz( int, int );                             /* Function  7 */
void mouse_setvert( int, int );                             /* Function  8 */
void mouse_settcurs( int, int, int );                       /* Function 10 */
void mouse_motion( int *horz_mickeys, int *vert_mickeys );  /* Function 11 */
void mouse_setratios( int horizontal, int vertical );       /* Function 15 */
void mouse_condoff( int x1, int y1, int x2, int y2  );      /* Function 16 */
void mouse_setdouble( int mickeys_per_second );             /* Function 19 */
void mouse_storage( int *buffer );                          /* Function 21 */
void mouse_save( char far *buffer );                        /* Function 22 */
void mouse_restore( char far *buffer );                     /* Function 23 */
void mouse_setsensitivity( int, int, int );                 /* Function 26 */
void mouse_getsensitivity( int *, int *, int * );           /* Function 27 */
void mouse_setmaxrate( int );                               /* Function 28 */
void mouse_setpage( int );                                  /* Function 29 */
void mouse_getpage( int * );                                /* Function 30 */
void mouse_region( int, int, int, int );
int mouse_button_pressed( int button_mask );
void mouse_row( int *vert_pos );
void mouse_col( int *horz_pos );

#define MOUSELIB_DEFINED
#endif

