*:*********************************************************************
*:
*:        Program: SET_FOX.PRG
*:
*:         System: MIS Consulting
*:         Author: Charles Alan Butler
*:      Copyright (c) 1989, Charles Alan Butler
*:  Last modified: 05/30/89     10:18
*:
*:      Called by: STARTPRG.PRG                  
*:               : BID.PRG                       
*:
*:      Documented 09/17/89 at 16:36                SNAP!  version 3.12f
*:*********************************************************************
*    set default to DRIVE - should be done by main program in system.
*
*    PROGRAMMER ATTENTION, THESE ARE NOT SET FOR THE FOLLOWING REASONS -
*    set filter to        - don't bother, no databases should be open.
*    set date to          - set by compiler public variables.
*    set order to         - should be done by programmer directly.
*    set path to          - un-predictable results can occur with the use of this command, therefore we don't use it.
*    set relation to      - don't bother, no databases should be open.
*    set margin to        - up to programmer to stay on top of this one.
*    set typeahead to     - don't bother, never changed by anyone.
*
* NOTE - Most of these are redundant, for they are as default is, but you
*        never know!!!
*
******************************** NOTES ********************************

* --- dBASE default SETTINGS
SET STEP Off            && No, don't interact with user after each line of code.  Execute normally.
SET ESCAPE OFF          && Can not interupt the program in progress
SET ECHO OFF            && Do not echo source code lines to screen
SET TALK OFF            && Do not echo file processing status to screen
SET COLOR TO BG/N,W+/R  && Default colors for this system
SET SCOREBOARD OFF      && We use the top line of the screen
SET STATUS OFF          && We don't want dBASE's status line
SET ALTERNATE TO        && Closes any open alternate ouput file.
SET BELL ON             && beep at the end of a field, or in valid .f. conditions.
SET CARRY Off           && Don't copy previous records data during append or insert.
SET CENTURY Off         && 2 digit year format.
SET CLEAR ON            && Clear the screen when QUIT or SET FORMAT TO is executed.
SET COLOR ON            && Colors are cool.
SET CONFIRM Off         && User does not need to hit return at the end of a field.
SET CONSOLE ON          && All output to screen appears on screen (off inhibits output to screen).
SET DEBUG Off           && Any output from SET ECHO ON goes to screen (on goes to printer).
SET DECIMALS TO 2       && Use ten decimal places in math functions.
SET DELETED ON          && Disallow access to any records marked DELETED.
SET DELIMITERS Off      && Don't bracket fields during full screen mode.
SET DEVICE TO SCREEN    && @ say output goes to screen.
SET DOHISTORY Off       && Stores program file command lines to HISTORY, where using UP/DOWN arrow retrieves them.
SET ESCAPE Off          && Shut off the Escape key, which causes Cancel, Ignore, Suspend.
SET EXACT ON            && Require Comparisons to Be Exact?
*-*set exact off           && Compare strings only till exhaustion, not completely.
SET EXCLUSIVE ON        && STAND ALONE SYSTEM - LOCAL DRIVE.
SET FIELDS Off          && Use all fields.
SET FIXED Off           && Use decimal places as needed in numeric output.
SET FORMAT TO           && Close any open format files.
SET HEADING ON          && Yes, display column titles during LIST, DISPLAY, SUM and AVERAGE
SET HISTORY ON          && Yes, store commands entered interactively into history.
SET INTENSITY ON        && Yes, use the enhanced screen attribute for input fields.
SET MEMOWIDTH TO 70     && Standard Memo Width is 70
SET MENU ON             && Yes, display a navigation bar during full screen entry operation.
SET PRINT Off           && Disable output to printer.  If on, output to screen goes to printer to, except for @ say out
SET PRINTER TO          && All printer output to MS-DOS device PRN.
SET PROCEDURE TO        && Close any open procedure files.
SET SAFETY OFF          && No messages when overwriting files
*-*set safety on           && Yes, warn us if a data file is going to be overwritten by a command.
SET UNIQUE Off          && Yes, allow duplicate keys to occur in the index file.

* Disable the Help Key F1 with a harmless task
*ON KEY = 315 SET TALK OFF
* Setup the function keys.
SET FUNCTION 2 TO CHR(31)   &&  [Ctrl] [PgUp] - Add Mode Command Call
SET FUNCTION 3 TO CHR(30)         && CTRL-PgDn
SET FUNCTION 4 TO CHR(23)+CHR(13) && CTRL-END + CR
**  FUNCTION 5 TO TODAYS DATE
SET FUNCTION 5 TO LEFT(DTOC(DATE()),2)+SUBSTR(DTOC(DATE()),4,2)+RIGHT(DTOC(DATE()),2)
SET FUNCTION 6  TO ""
SET FUNCTION 7  TO ""
SET FUNCTION 8  TO ""
SET FUNCTION 9  TO ""
SET FUNCTION 10 TO ""

public wt,operator,ScrnFlag
wt=300               &&  Seconds to time out
operator='Alan'
ScrnFlag=.F.         &&  Screen flag for second screen mode

CLEAR
RETURN
*: EOF: SET_FOX.PRG
