*****************************************************************************
*  testshad.prg                                                             *
*  by Scott McIntosh                                                        *
*  Placed in Public Domain 1989                                             *
*  8/19/89                                                                  *
*  tests shadow function with and without optional color parameters.        *
*  Test on both monochrome and color monitors.                              *

PRIVATE a, old_color, old_screen, old_row, old_col, i, j
a = ""

* save environment
old_row = ROW()
old_col = COL()
old_color = SETCOLOR()
SAVE SCREEN TO old_scr

IF ISCOLOR()  && color detected

   * fill screen with text
   SETCOLOR( "W/B" )
   CLEAR SCREEN
   a = REPLICATE( "ABCD1234", 500 )
   @ 0,0 SAY a

   *** Test Screen 1 - shadow with no optional parameters ***

   * draw box and add message
   SETCOLOR( "W/B" )
   @ 5,5 CLEAR TO 20,75
   @ 5,5 TO 20,75 DOUBLE
   @ 10,15 SAY "Default Drop shadow colors"
   
   * make drop shadow an wait for keypress
   shadow( 5, 5, 20, 75 )    && No Attributes
   @ 12,15 SAY "Press any for next example"
   INKEY(0)
   CLEAR TYPEAHEAD
   
   * Test Screen 2 - shadow with optional parameters
   
   * draw box and add message
   SETCOLOR( "W/B" )
   @ 5,5 CLEAR TO 20,75
   @ 5,5 TO 20,75 DOUBLE
   @ 10,15 SAY "Green/Cyan Drop shadow colors"
   
   * make drop shadow an wait for keypress
   shadow( 5, 5, 20, 75, 10, 3 )  && With attributes passed
   @ 12,15 SAY "Press any for next example"
   INKEY(0)
   CLEAR TYPEAHEAD

   *** Test 3 - Speed: Loop with shadow in each color ***

   * draw box and add message
   SETCOLOR( "W/B" )
   @ 5,5 CLEAR TO 20,75
   @ 5,5 TO 20,75 DOUBLE
   @ 10,15 SAY "Press a key to Start Speed test"
   INKEY(0)
   
   * make 64 Drop Shadows, wait for keypress to end
   FOR i = 0 TO 7
      FOR j = 0 TO 7
         shadow( 5, 5, 20, 75, i, j )  && With attributes passed
      NEXT
   NEXT

   @ 12,15 SAY "Done! (64 Shadows) - Press any to quit"
   INKEY(0)
   CLEAR TYPEAHEAD


ELSE   && Monochrome

   * fill screen with text
   SETCOLOR( "W+/N" )
   CLEAR SCREEN
   a = REPLICATE( "ABCD1234", 500 )
   @ 0,0 SAY a

   *** Test Screen 1 - shadow with no optional parameters ***

   * draw box and add message
   SETCOLOR( "N/W" )
   @ 5,5 CLEAR TO 20,75
   SETCOLOR( "W/N" )
   @ 5,5 TO 20,75 DOUBLE
   @ 10,15 SAY "White on Black with Default Drop shadow colors"
   
   * make drop shadow an wait for keypress
   shadow( 5, 5, 20, 75 )    && No Attributes
   @ 12,15 SAY "Press any for next example"
   INKEY(0)
   CLEAR TYPEAHEAD
   
   
   * Test Screen 2 - shadow with optional parameters
   
   * draw box and add message
   SETCOLOR( "N/W" )
   @ 5,5 CLEAR TO 20,75
   SETCOLOR( "W/N" )
   @ 5,5 TO 20,75 DOUBLE
   @ 10,15 SAY "White on Black with Black on Black Drop shadow colors"
   
   * make drop shadow an wait for keypress
   shadow( 5, 5, 20, 75, 0, 0 )  && With attributes passed
   @ 12,15 SAY "Press any for next example"
   INKEY(0)
   CLEAR TYPEAHEAD

ENDIF

* restore environment
SETCOLOR( old_color )
RESTORE SCREEN FROM old_scr
@ old_row, old_col SAY ""

RETURN
