/***
*       twInkey.ch
*       Standard INKEY() key-code definitions
*       Copyright (c) 1990-1991 Nantucket Corp.  All rights reserved.
*
*       Additions by Trilateral Systems Development Ltd.
*/

//-----------------------------------------------------------------
// Cursor movement keys
//-----------------------------------------------------------------
#define K_UP            5       // Uparrow, Ctrl-E
#define K_DOWN          24      // Dnarrow, Ctrl-X
#define K_LEFT          19      // Leftarrow, Ctrl-S
#define K_RIGHT         4       // Rightarrow, Ctrl-D
#define K_HOME          1       // Home, Ctrl-A
#define K_END           6       // End, Ctrl-F
#define K_PGUP          18      // PgUp, Ctrl-R
#define K_PGDN          3       // PgDn, Ctrl-C

#define K_SH_UP         05      // Sh_Up
#define K_SH_DOWN       24      // Sh_Down
#define K_SH_LEFT       19      // Sh_Left
#define K_SH_RIGHT      04      // Sh_Right
#define K_SH_HOME       01      // Sh_Home
#define K_SH_END        06      // Sh_End
#define K_SH_PGUP       18      // Sh_Pgup
#define K_SH_PGDN       03      // Sh_Pgdn

#define K_CTRL_UP       397     // Ctrl_Up
#define K_CTRL_DOWN     401     // Ctrl_Down
#define K_CTRL_LEFT     26      // Ctrl-Leftarrow, Ctrl-Z
#define K_CTRL_RIGHT    2       // Ctrl-Rightarrow, Ctrl-B
#define K_CTRL_HOME     29      // Ctrl-Home, Ctrl-]
#define K_CTRL_END      23      // Ctrl-End, Ctrl-W
#define K_CTRL_PGUP     31      // Ctrl-PgUp, Ctrl-Hyphen
#define K_CTRL_PGDN     30      // Ctrl-PgDn, Ctrl-^

#define K_ALT_UP        408     // Alt_Up
#define K_ALT_DOWN      416     // Alt_Down
#define K_ALT_LEFT      411     // Alt_Left
#define K_ALT_RIGHT     413     // Alt_Right
#define K_ALT_HOME      407     // Alt_Home
#define K_ALT_END       415     // Alt_End
#define K_ALT_PGUP      409     // Alt_Pgup
#define K_ALT_PGDN      417     // Alt_Pgdn

//-----------------------------------------------------------------
// selection keys
//-----------------------------------------------------------------
#define K_ESC           27      // Esc, Ctrl-[
#define K_ENTER         13      // Enter, Ctrl-M
#define K_RETURN        13      // Return, Ctrl-M
#define K_SPACE         32      // Space Bar

#define K_CTRL_ESC      27      // Ctrl_Esc
#define K_CTRL_ENTER    10      // Ctrl-Return
#define K_CTRL_RETURN   10      // Ctrl-Return
#define K_CTRL_SPACE    32      // Ctrl_Spacebar

#define K_SH_ESC        27      // Sh_Esc
#define K_SH_ENTER      13      // Sh_Enter
#define K_SH_RETURN     13      // Sh_Return
#define K_SH_SPACE      32      // Sh_Spacebar

#define K_ALT_ESC       257     // Alt_Esc
#define K_ALT_ENTER     284     // Alt_Enter
#define K_ALT_RETURN    284     // Alt_Return
#define K_ALT_SPACE      32     // Alt_Spacebar

//-----------------------------------------------------------------
// Editing keys
//-----------------------------------------------------------------
#define K_INS           22      // Ins, Ctrl-V
#define K_DEL           7       // Del, Ctrl-G
#define K_BS            8       // Backspace, Ctrl-H
#define K_TAB           9       // Tab, Ctrl-I

#define K_CTRL_INS      402     // Ctrl_Insert
#define K_CTRL_DEL      403     // Ctrl_Delete
#define K_CTRL_BS       127     // Ctrl-Backspace
#define K_CTRL_TAB      404     // Ctrl_Tab

#define K_SH_INS        22      // Sh_Insert
#define K_SH_DEL        07      // Sh_Delete
#define K_SH_BS         08      // Sh_Backspace
#define K_SH_TAB        271     // Shift-Tab

#define K_ALT_INS       418     // Alt_Insert
#define K_ALT_DEL       419     // Alt_Delete
#define K_ALT_BS        270     // Alt_Backspace
#define K_ALT_TAB       421     // Alt_Tab

//-----------------------------------------------------------------
// Alpha keys
//-----------------------------------------------------------------
#define K_A             97      // a
#define K_B             98      // b
#define K_C             99      // c
#define K_D             100     // d
#define K_E             101     // e
#define K_F             102     // f
#define K_G             103     // g
#define K_H             104     // h
#define K_I             105     // i
#define K_J             106     // j
#define K_K             107     // k
#define K_L             108     // l
#define K_M             109     // m
#define K_N             110     // n
#define K_O             111     // o
#define K_P             112     // p
#define K_Q             113     // q
#define K_R             114     // r
#define K_S             115     // s
#define K_T             116     // t
#define K_U             117     // u
#define K_V             118     // v
#define K_W             119     // w
#define K_X             120     // x
#define K_Y             121     // y
#define K_Z             122     // z
#define K_LF_BRKT       91      // [
#define K_RT_BRKT       93      // ]
#define K_BK_SLASH      92      // \
#define K_SEMI          59      // ;
#define K_APPOS         39      // '
#define K_COMMA         44      // ,
#define K_PERIOD        46      // .
#define K_SLASH         47      // /

#define K_CTRL_A        1       // Ctrl-A, Home
#define K_CTRL_B        2       // Ctrl-B, Ctrl-Rightarrow
#define K_CTRL_C        3       // Ctrl-C, PgDn, Ctrl-ScrollLock
#define K_CTRL_D        4       // Ctrl-D, Rightarrow
#define K_CTRL_E        5       // Ctrl-E, Uparrow
#define K_CTRL_F        6       // Ctrl-F, End
#define K_CTRL_G        7       // Ctrl-G, Del
#define K_CTRL_H        8       // Ctrl-H, Backspace
#define K_CTRL_I        9       // Ctrl-I, Tab
#define K_CTRL_J        10      // Ctrl-J
#define K_CTRL_K        11      // Ctrl-K
#define K_CTRL_L        12      // Ctrl-L
#define K_CTRL_M        13      // Ctrl-M, Return
#define K_CTRL_N        14      // Ctrl-N
#define K_CTRL_O        15      // Ctrl-O
#define K_CTRL_P        16      // Ctrl-P
#define K_CTRL_Q        17      // Ctrl-Q
#define K_CTRL_R        18      // Ctrl-R, PgUp
#define K_CTRL_S        19      // Ctrl-S, Leftarrow
#define K_CTRL_T        20      // Ctrl-T
#define K_CTRL_U        21      // Ctrl-U
#define K_CTRL_V        22      // Ctrl-V, Ins
#define K_CTRL_W        23      // Ctrl-W, Ctrl-End
#define K_CTRL_X        24      // Ctrl-X, Dnarrow
#define K_CTRL_Y        25      // Ctrl-Y
#define K_CTRL_Z        26      // Ctrl-Z, Ctrl-Leftarrow
#define K_CTRL_LF_BRKT  27      // Ctrl_Left Bracket
#define K_CTRL_RT_BRKT  29      // Ctrl_Right Bracket
#define K_CTRL_BK_SLASH 28      // Ctrl_Back Slash

#define K_SH_A          65      // A
#define K_SH_B          66      // B
#define K_SH_C          67      // C
#define K_SH_D          68      // D
#define K_SH_E          69      // E
#define K_SH_F          70      // F
#define K_SH_G          71      // G
#define K_SH_H          72      // H
#define K_SH_I          73      // I
#define K_SH_J          74      // J
#define K_SH_K          75      // K
#define K_SH_L          76      // L
#define K_SH_M          77      // M
#define K_SH_N          78      // N
#define K_SH_O          79      // O
#define K_SH_P          80      // P
#define K_SH_Q          81      // Q
#define K_SH_R          82      // R
#define K_SH_S          83      // S
#define K_SH_T          84      // T
#define K_SH_U          85      // U
#define K_SH_V          86      // V
#define K_SH_W          87      // W
#define K_SH_X          88      // X
#define K_SH_Y          89      // Y
#define K_SH_Z          90      // Z
#define K_LF_BRACE      123     // {
#define K_RT_BRACE      125     // }
#define K_V_BAR         124     // |
#define K_COLON         58      // :
#define K_QUOTE         34      // "
#define K_LESS_THAN     60      // <
#define K_GREATER_THAN  62      // >
#define K_QUESTION      63      // ?

#define K_ALT_A         286     // Alt-A
#define K_ALT_B         304     // Alt-B
#define K_ALT_C         302     // Alt-C
#define K_ALT_D         288     // Alt-D
#define K_ALT_E         274     // Alt-E
#define K_ALT_F         289     // Alt-F
#define K_ALT_G         290     // Alt-G
#define K_ALT_H         291     // Alt-H
#define K_ALT_I         279     // Alt-I
#define K_ALT_J         292     // Alt-J
#define K_ALT_K         293     // Alt-K
#define K_ALT_L         294     // Alt-L
#define K_ALT_M         306     // Alt-M
#define K_ALT_N         305     // Alt-N
#define K_ALT_O         280     // Alt-O
#define K_ALT_P         281     // Alt-P
#define K_ALT_Q         272     // Alt-Q
#define K_ALT_R         275     // Alt-R
#define K_ALT_S         287     // Alt-S
#define K_ALT_T         276     // Alt-T
#define K_ALT_U         278     // Alt-U
#define K_ALT_V         303     // Alt-V
#define K_ALT_W         273     // Alt-W
#define K_ALT_X         301     // Alt-X
#define K_ALT_Y         277     // Alt-Y
#define K_ALT_Z         300     // Alt-Z
#define K_ALT_LF_BRKT   282     // Alt_Left Bracket
#define K_ALT_RT_BRKT   283     // Alt_Right Bracket
#define K_ALT_BK_SLASH  299     // Alt_Back Slash
#define K_ALT_SEMI      295     // Alt_Semi Colon
#define K_ALT_APPOS     296     // Alt_Apostrophe
#define K_ALT_COMMA     307     // Alt_Comma
#define K_ALT_PERIOD    308     // Alt_Period
#define K_ALT_SLASH     309     // Alt_Slash

//-----------------------------------------------------------------
// Number keys
//-----------------------------------------------------------------
#define K_BK_APPOS      96      // `
#define K_1             49      // 1
#define K_2             50      // 2
#define K_3             51      // 3
#define K_4             52      // 4
#define K_5             53      // 5
#define K_6             54      // 6
#define K_7             55      // 7
#define K_8             56      // 8
#define K_9             57      // 9
#define K_0             48      // 0
#define K_MINUS         45      // -
#define K_EQUAL         61      // =

#define K_CTRL_2        259     // C_2
#define K_CTRL_6        30      // ^_6
#define K_CTRL_MINUS    31      // ^_-

#define K_TILDE         126     // ~
#define K_EXCLAM        33      // !
#define K_AT            64      // @
#define K_NUMBER        35      // #
#define K_POUND         35      // #
#define K_DOLLAR        36      // $
#define K_PERCENT       37      // %
#define K_CARET         94      // ^
#define K_AMPERSAND     38      // &
#define K_ASTERISK      42      // *
#define K_LF_PAREN      40      // (
#define K_RT_PAREN      41      // )
#define K_UNDERSCORE    95      // _
#define K_PLUS          43      // +

#define K_ALT_BK_APPOS  297     // ALT_Back Apostrophe
#define K_ALT_1         376     // Alt-1
#define K_ALT_2         377     // Alt-2
#define K_ALT_3         378     // Alt-3
#define K_ALT_4         379     // Alt-4
#define K_ALT_5         380     // Alt-5
#define K_ALT_6         381     // Alt-6
#define K_ALT_7         382     // Alt-7
#define K_ALT_8         383     // Alt-8
#define K_ALT_9         384     // Alt-9
#define K_ALT_0         385     // Alt-0
#define K_ALT_MINUS     386     // Alt_-
#define K_ALT_EQUAL     387     // Alt_=

//-----------------------------------------------------------------
// Function keys
//-----------------------------------------------------------------
#define K_F1            28      // F1, Ctrl-\
#define K_F2            -1      // F2
#define K_F3            -2      // F3
#define K_F4            -3      // F4
#define K_F5            -4      // F5
#define K_F6            -5      // F6
#define K_F7            -6      // F7
#define K_F8            -7      // F8
#define K_F9            -8      // F9
#define K_F10           -9      // F10
#define K_F11           -40     // F11
#define K_F12           -41     // F12

// Control-function keys
#define K_CTRL_F1       -20     // Ctrl-F1
#define K_CTRL_F2       -21     // Ctrl-F2
#define K_CTRL_F3       -22     // Ctrl-F4
#define K_CTRL_F4       -23     // Ctrl-F3
#define K_CTRL_F5       -24     // Ctrl-F5
#define K_CTRL_F6       -25     // Ctrl-F6
#define K_CTRL_F7       -26     // Ctrl-F7
#define K_CTRL_F8       -27     // Ctrl-F8
#define K_CTRL_F9       -28     // Ctrl-F9
#define K_CTRL_F10      -29     // Ctrl-F10
#define K_CTRL_F11      -44     // Ctrl-F11
#define K_CTRL_F12      -45     // Ctrl-F12

// Shift-function keys
#define K_SH_F1         -10     // Shift-F1
#define K_SH_F2         -11     // Shift-F2
#define K_SH_F3         -12     // Shift-F3
#define K_SH_F4         -13     // Shift-F4
#define K_SH_F5         -14     // Shift-F5
#define K_SH_F6         -15     // Shift-F6
#define K_SH_F7         -16     // Shift-F7
#define K_SH_F8         -17     // Shift-F8
#define K_SH_F9         -18     // Shift-F9
#define K_SH_F10        -19     // Shift-F10
#define K_SH_F11        -42     // Shift-F11
#define K_SH_F12        -43     // Shift-F12

// Alt-function keys
#define K_ALT_F1        -30     // Alt-F1
#define K_ALT_F2        -31     // Alt-F2
#define K_ALT_F3        -32     // Alt-F3
#define K_ALT_F4        -33     // Alt-F4
#define K_ALT_F5        -34     // Alt-F5
#define K_ALT_F6        -35     // Alt-F6
#define K_ALT_F7        -36     // Alt-F7
#define K_ALT_F8        -37     // Alt-F8
#define K_ALT_F9        -38     // Alt-F9
#define K_ALT_F10       -39     // Alt-F10
#define K_ALT_F11       -46     // Alt-F11
#define K_ALT_F12       -47     // Alt-F12


